diff -cNr ivtools-0.6.orig/src/IV-X11/xfont.c ivtools-0.6/src/IV-X11/xfont.c
*** ivtools-0.6.orig/src/IV-X11/xfont.c	Wed Jan 21 09:28:04 1998
--- ivtools-0.6/src/IV-X11/xfont.c	Thu Jan 29 00:44:33 1998
***************
*** 32,37 ****
--- 32,40 ----
  #include <IV-X11/Xlib.h>
  #include <IV-X11/xdisplay.h>
  #include <IV-X11/xfont.h>
+ #ifdef JIV
+ #include <IV-X11/xjivfunc.h>
+ #endif /* JIV */
  #include <OS/list.h>
  #include <OS/math.h>
  #include <OS/string.h>
***************
*** 88,93 ****
--- 91,100 ----
      static FontRep* find_rep(FontRepList&, Display*, float);
      static FontRep* create(Display*, const String&, float);
      static const Font* new_font(const String&, float, KnownFonts*, FontRep*);
+ #ifdef JIV
+     static const Font* new_font(const String&, float, KnownFonts*,
+ 				FontRep*, FontRep*);
+ #endif /* JIV */
      static KnownFonts* known(KnownFonts*, const UniqueString&);
  
      UniqueString* name_;
***************
*** 194,199 ****
--- 201,210 ----
      FontRep* r;
      KnownFonts* k = nil;
      UniqueString uname(name);
+ #ifdef JIV
+     NullTerminatedString nname(uname);
+     const CompositeFont* cf;
+ #endif /* JIV */
      if (fonts()->find(k, uname)) {
  	for (ListItr(FontList) i(k->fonts); i.more(); i.next()) {
  	    f = i.cur();
***************
*** 202,213 ****
--- 213,251 ----
  	    }
  	}
  
+ #ifndef JIV
  	r = find_rep(k->fontreps, d, scale);
  	if (r != nil) {
  	    return new_font(uname, scale, k, r);
  	}
+ #else /* JIV */
+ 	if ((cf = CompositeFont::findCompositeFont(nname.string())) == nil) {
+ 	    r = find_rep(k->fontreps, d, scale);
+ 	    if (r != nil) {
+ 		return new_font(uname, scale, k, r);
+ 	    }
+ 	}
+ #endif /* JIV */
      }
  
+ #ifdef JIV
+     if ((cf = CompositeFont::findCompositeFont(nname.string())) != nil) {
+ 	const Font* f1;
+ 	const Font* f2;
+ 
+ 	f1 = FontImpl::lookup(d, String(cf->get1ByteFontName()), scale);
+ 	if (f1 == nil) {
+ 	    return nil;
+ 	}
+ 	f2 = FontImpl::lookup(d, String(cf->get2ByteFontName()), scale);
+ 	if (f2 == nil) {
+ 	    return nil;
+ 	}
+ 	k = known(k, uname);
+ 	f = new_font(uname, scale, k, f1->rep(d), f2->rep(d));
+ 	return f;
+     }
+ #endif /* JIV */
      r = create(d, uname, scale);
      if (r == nil) {
  	return nil;
***************
*** 280,285 ****
--- 318,334 ----
      return f;
  }
  
+ #ifdef JIV
+ const Font* FontImpl::new_font(
+     const String& name, float scale, KnownFonts* k,
+     FontRep*, FontRep*
+ ) {
+     Font* f = new Font(name, scale);
+     k->fonts.append(f);
+     return f;
+ }
+ #endif /* JIV */
+ 
  KnownFonts* FontImpl::known(KnownFonts* old_k, const UniqueString& name) {
      if (old_k != nil) {
  	return old_k;
***************
*** 314,332 ****
--- 363,417 ----
  /** class Font **/
  
  Font::Font(const String& name, float scale) {
+ #ifdef JIV
+     const CompositeFont* cf;
+     NullTerminatedString s(name);
+ 
+     if ((cf = CompositeFont::findCompositeFont(s.string())) != nil) {
+ 	cfont = cf;
+ 	impl_ = new FontImpl(String(cf->get1ByteFontName()), scale);
+ 	impl2byte_ = new FontImpl(String(cf->get2ByteFontName()), scale);
+ 	isCompositeFlag = true;
+ 	return;
+     }
+     isCompositeFlag = false;
+     impl2byte_ = nil;
+ #endif /* JIV */
      impl_ = new FontImpl(name, scale);
  }
  
  Font::Font(const char* name, float scale) {
+ #ifdef JIV
+     const CompositeFont* cf;
+ 
+     if ((cf = CompositeFont::findCompositeFont(name)) != nil) {
+ 	cfont = cf;
+ 	impl_ = new FontImpl(String(cf->get1ByteFontName()), scale);
+ 	impl2byte_ = new FontImpl(String(cf->get2ByteFontName()), scale);
+ 	isCompositeFlag = true;
+ 	return;
+     }
+     impl2byte_ = nil;
+     isCompositeFlag = false;
+ #endif /* JIV */
+ 
      impl_ = new FontImpl(String(name), scale);
  }
  
  Font::Font(FontImpl* i) {
      impl_ = i;
+ #ifdef JIV
+     isCompositeFlag = false;
+     impl2byte_ = nil;
+ #endif /* JIV */
  }
  
  Font::~Font() {
      delete impl_;
+ #ifdef JIV
+     isCompositeFlag = false;
+     impl2byte_ = nil;
+ #endif /* JIV */
  }
  
  void Font::cleanup() {
***************
*** 357,363 ****
--- 442,462 ----
      return impl_->rep(d);
  }
  
+ #ifdef JIV
+ FontRep* Font::rep2byte(Display* d) const {
+     if (!isComposite()) {
+ 	return nil;
+     }
+     return impl2byte_->rep(d);
+ }
+ #endif JIV
+ 
  const char* Font::name() const {
+ #ifdef JIV
+     if (isComposite()) {
+ 	return cfont->getFontName();
+     }
+ #endif /* JIV */
      FontRep* f = impl_->default_rep();
      return f->name_->string();
  }
***************
*** 376,381 ****
--- 475,502 ----
      float scale = f->scale_;
      XFontStruct* xf = f->font_;
      Display* d = f->display_;
+ #ifdef	JIV
+     if (isComposite()) {
+ 	FontRep* f2 = impl2byte_->default_rep();
+ 	XFontStruct* xf2 = f2->font_;
+ 	b.left_bearing_ = scale *
+ 	    d->to_coord(Math::max(xf->max_bounds.lbearing,
+ 				  xf2->max_bounds.lbearing));
+ 	b.right_bearing_ = scale *
+ 	    d->to_coord(Math::max(xf->max_bounds.rbearing,
+ 				  xf2->max_bounds.rbearing));
+ 	b.width_ = scale *
+ 	    d->to_coord(Math::max(xf->max_bounds.width,
+ 				  xf2->max_bounds.width));
+ 	b.ascent_ = scale * d->to_coord(Math::max(xf->ascent,
+ 						  xf2->ascent));
+ 	b.descent_ = scale * d->to_coord(Math::max(xf->descent,
+ 						   xf2->descent));
+ 	b.font_ascent_ = b.ascent_;
+ 	b.font_descent_ = b.descent_;
+ 	return;
+     }
+ #endif	JIV
      b.left_bearing_ = scale * d->to_coord(xf->max_bounds.lbearing);
      b.right_bearing_ = scale * d->to_coord(xf->max_bounds.rbearing);
      b.width_ = scale * d->to_coord(xf->max_bounds.width);
***************
*** 397,402 ****
--- 518,528 ----
  	return;
      }
      FontRep* f = impl_->default_rep();
+ #ifdef JIV
+     if ((c & 0xff00) && isComposite()) {
+ 	f = impl2byte_->default_rep();
+     }
+ #endif /* JIV */
      float scale = f->scale_;
      XFontStruct* xf = f->font_;
      Display* d = f->display_;
***************
*** 422,433 ****
--- 548,581 ----
      Display* d = f->display_;
      XCharStruct c;
      int dir, asc, des;
+ #ifdef JIV
+     if (isComposite()) {
+ 	c.lbearing = JIVGetLeftBearing(s, len, f, impl2byte_->default_rep());
+ 	c.rbearing = JIVGetRightBearing(s, len, f, impl2byte_->default_rep());
+ 	c.descent = JIVGetDescent(s, len, f, impl2byte_->default_rep());
+ 	c.ascent = JIVGetAscent(s, len, f, impl2byte_->default_rep());
+     } else {
+ #endif JIV
      XTextExtents(xf, s, len, &dir, &asc, &des, &c);
+ #ifdef JIV
+     }
+ #endif JIV
      b.left_bearing_ = scale * d->to_coord(-c.lbearing);
      b.right_bearing_ = scale * d->to_coord(c.rbearing);
      b.width_ = width(s, len);
      b.ascent_ = scale * d->to_coord(c.ascent);
      b.descent_ = scale * d->to_coord(c.descent);
+ #ifdef JIV
+     if (isComposite()) {
+ 	FontRep* f2 = impl2byte_->default_rep();
+ 	XFontStruct* xf2 = f2->font_;
+ 	b.font_ascent_ = scale * d->to_coord(Math::max(xf->ascent,
+ 						       xf2->ascent));
+ 	b.font_descent_ = scale * d->to_coord(Math::max(xf->descent,
+ 							xf2->descent));
+ 	return;
+     }
+ #endif JIV
      b.font_ascent_ = scale * d->to_coord(xf->ascent);
      b.font_descent_ = scale * d->to_coord(xf->descent);
  }
***************
*** 437,442 ****
--- 585,595 ----
  	return 0;
      }
      FontRep* f = impl_->default_rep();
+ #ifdef JIV
+     if ((c & 0xff00) && isComposite()) {
+ 	f = impl2byte_->default_rep();
+     }
+ #endif /* JIV */
      XChar2b xc2b;
      xc2b.byte1 = (unsigned char)((c & 0xff00) >> 8);
      xc2b.byte2 = (unsigned char)(c & 0xff);
***************
*** 445,450 ****
--- 598,609 ----
  
  Coord Font::width(const char* s, int len) const {
      FontRep* f = impl_->default_rep();
+ #ifdef JIV
+     if (isComposite()) {
+ 	short w = JIVGetWidth(s, len, f, impl2byte_->default_rep());
+ 	return f->display_->to_coord(w) * f->scale_;
+     }	
+ #endif /* JIV */
      return f->scale_ * f->display_->to_coord(XTextWidth(f->font_, s, len));
  }
  
***************
*** 458,465 ****
      }
      FontRep* f = impl_->default_rep();
      XFontStruct* xf = f->font_;
      int xoffset = f->display_->to_pixels(Coord(offset * f->scale_));
!     if (xf->min_bounds.width == xf->max_bounds.width) {
          cw = xf->min_bounds.width;
          n = xoffset / cw;
          coff = xoffset % cw;
--- 617,634 ----
      }
      FontRep* f = impl_->default_rep();
      XFontStruct* xf = f->font_;
+ #ifdef JIV
+     XFontStruct* xf2 = nil;
+     if (isComposite()) {
+ 	xf2 = impl2byte_->default_rep()->font_;
+     }
+ #endif /* JIV */
      int xoffset = f->display_->to_pixels(Coord(offset * f->scale_));
!     if ((xf->min_bounds.width == xf->max_bounds.width)
! #ifdef JIV
! 	&& (xf2 == nil)
! #endif /* JIV */
! 	) {
          cw = xf->min_bounds.width;
          n = xoffset / cw;
          coff = xoffset % cw;
***************
*** 467,473 ****
--- 636,652 ----
          w = 0;
          cw = 0;
          for (p = s, n = 0; *p != '\0' && n < len; ++p, ++n) {
+ #ifndef JIV
              cw = XTextWidth(xf, p, 1);
+ #else /* JIV */
+ 	    if (((const unsigned char)(*p) < 0xa1) || (xf2 == nil)) {
+ 		cw = XTextWidth(xf, p, 1);
+ 	    } else {
+ 		cw = XTextWidth16(xf2, (XChar2b*)p, 1);
+ 		p++;
+ 		n++;
+ 	    }
+ #endif /* JIV */
              w += cw;
              if (w > xoffset) {
                  break;
***************
*** 749,751 ****
--- 928,1194 ----
      scale = (size == best_size) ? 1.0 : float(size)/float(best_size);
      return true;
  }
+ 
+ #ifdef JIV
+ /** class CompositeFont **/
+ 
+ declarePtrList(CompositeFontList,CompositeFont);
+ implementPtrList(CompositeFontList,CompositeFont);
+ 
+ static CompositeFontList cflist;
+ 
+ CompositeFont::CompositeFont(const char* fc, const char* f1,
+ 			     const char* f2, const char* style)
+ {
+     CompositeFont*	cf;
+ 
+     compositeFontName = new char[strlen(fc) + 1];
+     strcpy(compositeFontName, fc);
+     fontName1 = new char[strlen(f1) + 1];
+     strcpy(fontName1, f1);
+     fontName2 = new char[strlen(f2) + 1];
+     strcpy(fontName2, f2);
+     displayBoldFlag = false;
+     displayItalicFlag = false;
+     if (style != 0) {
+ 	if (strchr(style, 'b')) {
+ 	    displayBoldFlag = true;
+ 	}
+ 	if (strchr(style, 'i')) {
+ 	    displayItalicFlag = true;
+ 	}
+     }
+ 
+     cf = this;
+     cflist.append(cf);
+ }
+ 
+ CompositeFont::~CompositeFont()
+ {
+     delete compositeFontName;
+     delete fontName1;
+     delete fontName2;
+ 
+     for (long i = 0; i < cflist.count(); i++) {
+ 	CompositeFont* cf = cflist.item(i);
+ 	if (cf == this) {
+ 	    cflist.remove(i);
+ 	    break;
+ 	}
+     }
+ }
+ 
+ const CompositeFont* CompositeFont::findCompositeFont(const char* cfname)
+ {
+     for (long i = 0; i < cflist.count(); i++) {
+ 	CompositeFont* cf = cflist.item(i);
+ 	if (!strcmp(cf->compositeFontName, cfname)) {
+ 	    return cf;
+ 	}
+     }
+     return nil;
+ }
+ 
+ /** class PSCompositeFont **/
+ 
+ class PSCompositeFontRep {
+   public:
+     PSCompositeFontRep(char*, char*, char*);
+     ~PSCompositeFontRep();
+ 
+     static char* preamble;
+ 
+     char* fontname;
+     char* asciiFontname;
+     char* kanjiFontname;
+ };
+ 
+ char* PSCompositeFontRep::preamble;
+ 
+ PSCompositeFontRep::PSCompositeFontRep(
+   char* fn, char* f1, char* f2
+ ) {
+     fontname = fn;
+     asciiFontname = f1;
+     kanjiFontname = f2;
+ }
+ 
+ PSCompositeFontRep::~PSCompositeFontRep()
+ {
+     delete fontname;
+     delete asciiFontname;
+     delete kanjiFontname;
+ }
+ 
+ declarePtrList(PSCompositeFontList,PSCompositeFont);
+ implementPtrList(PSCompositeFontList,PSCompositeFont);
+ 
+ static PSCompositeFontList pscflist;
+ 
+ void PSCompositeFont::setPreamble(const char* p) {
+     if (PSCompositeFontRep::preamble != 0) {
+ 	delete PSCompositeFontRep::preamble;
+     }
+     PSCompositeFontRep::preamble = new char[strlen(p) + 1];
+     strcpy(PSCompositeFontRep::preamble, p);
+ }
+ 
+ const char* PSCompositeFont::getPreamble() {
+     return PSCompositeFontRep::preamble;
+ }
+ 
+ PSCompositeFont::PSCompositeFont(
+   const char* fc, const char* f1, const char* f2
+ ) {
+     PSCompositeFont*	cf;
+     char*	fn;
+     char*	fa;
+     char*	fk;
+ 
+     fn = new char[strlen(fc) + 1];
+     strcpy(fn, fc);
+     fa = new char[strlen(f1) + 1];
+     strcpy(fa, f1);
+     fk = new char[strlen(f2) + 1];
+     strcpy(fk, f2);
+ 
+     rep_ = new PSCompositeFontRep(fn, fa, fk);
+ 
+     cf = this;
+     pscflist.append(cf);
+ }
+ 
+ PSCompositeFont::~PSCompositeFont()
+ {
+     delete rep_;
+ 
+     for (long i = 0; i < pscflist.count(); i++) {
+ 	PSCompositeFont* cf = pscflist.item(i);
+ 	if (cf == this) {
+ 	    pscflist.remove(i);
+ 	    break;
+ 	}
+     }
+ }
+ 
+ const PSCompositeFont* PSCompositeFont::findFont(const char* cfname)
+ {
+     for (long i = 0; i < pscflist.count(); i++) {
+ 	PSCompositeFont* cf = pscflist.item(i);
+ 	if (!strcmp(cf->rep_->fontname, cfname)) {
+ 	    return cf;
+ 	}
+     }
+     return nil;
+ }
+ 
+ const char* PSCompositeFont::getFontName() const {
+     return rep_->fontname;
+ }
+ 
+ const char* PSCompositeFont::getAsciiFontName() const {
+     return rep_->asciiFontname;
+ }
+ 
+ const char* PSCompositeFont::getKanjiFontName() const {
+     return rep_->kanjiFontname;
+ }
+ 
+ /** class PSSlantFont **/
+ 
+ class PSSlantFontRep {
+   public:
+     PSSlantFontRep(char*, char*);
+     ~PSSlantFontRep();
+ 
+     char*	fontname;
+     char*	originalFontname;
+     boolean	printFlag;
+ };
+ 
+ PSSlantFontRep::PSSlantFontRep(
+   char* fn, char* fo
+ ) {
+     fontname = fn;
+     originalFontname = fo;
+     printFlag = false;
+ }
+ 
+ PSSlantFontRep::~PSSlantFontRep()
+ {
+     delete fontname;
+     delete originalFontname;
+ }
+ 
+ declarePtrList(PSSlantFontList,PSSlantFont);
+ implementPtrList(PSSlantFontList,PSSlantFont);
+ 
+ static PSSlantFontList pssflist;
+ 
+ PSSlantFont::PSSlantFont(
+   const char* fc, const char* f1
+ ) {
+     PSSlantFont*	sf;
+     char*	fn;
+     char*	fo;
+ 
+     fn = new char[strlen(fc) + 1];
+     strcpy(fn, fc);
+     fo = new char[strlen(f1) + 1];
+     strcpy(fo, f1);
+ 
+     rep_ = new PSSlantFontRep(fn, fo);
+ 
+     sf = this;
+     pssflist.append(sf);
+ }
+ 
+ PSSlantFont::~PSSlantFont()
+ {
+     delete rep_;
+ 
+     for (long i = 0; i < pssflist.count(); i++) {
+ 	PSSlantFont* sf = pssflist.item(i);
+ 	if (sf == this) {
+ 	    pssflist.remove(i);
+ 	    break;
+ 	}
+     }
+ }
+ 
+ PSSlantFont* PSSlantFont::findFont(const char* sfname)
+ {
+     for (long i = 0; i < pssflist.count(); i++) {
+ 	PSSlantFont* sf = pssflist.item(i);
+ 	if (!strcmp(sf->rep_->fontname, sfname)) {
+ 	    return sf;
+ 	}
+     }
+     return nil;
+ }
+ 
+ void PSSlantFont::resetPrintFlag()
+ {
+     for (long i = 0; i < pssflist.count(); i++) {
+ 	PSSlantFont* sf = pssflist.item(i);
+ 	sf->rep_->printFlag = false;
+     }
+ }
+ 
+ const char* PSSlantFont::getFontName() const {
+     return rep_->fontname;
+ }
+ 
+ const char* PSSlantFont::getOriginalFontName() const {
+     return rep_->originalFontname;
+ }
+ 
+ boolean PSSlantFont::printFlag() {
+     return rep_->printFlag;
+ }
+ 
+ void PSSlantFont::printFlag(boolean t) {
+     rep_->printFlag = t;
+ }
+ 
+ #endif JIV
diff -cNr ivtools-0.6.orig/src/IV-X11/xjivfunc.c ivtools-0.6/src/IV-X11/xjivfunc.c
*** ivtools-0.6.orig/src/IV-X11/xjivfunc.c	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/IV-X11/xjivfunc.c	Wed Jan 28 20:32:12 1998
***************
*** 0 ****
--- 1,492 ----
+ /*
+  * Copyright (c) 1991, 1992 Fujitsu Oita Software Laboratory Limited
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose is hereby granted without fee, provided
+  * that the above copyright notice and this permission notice appear in
+  * all copies of the software and related documentation, and the name of
+  * Fujitsu Oita Software Laboratory may not be used in any advertising or
+  * publicity relating to the software without specific, prior written
+  * prior permission of Fujitsu Oita Software Laboratory. 
+  * 
+  * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+  * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+  * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+  *
+  * IN NO EVENT SHALL FUJITSU OITA SOFTWARE LABORATORY BE LIABLE FOR ANY
+  * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR
+  * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+  * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY
+  * OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+  * PERFORMANCE OF THIS SOFTWARE.
+  *
+  * Author:  Toshihisa Eto, Fujitsu Oita Software Laboratory Limited, Japan
+  * 	E-Mail: eto@ai.cs.fujitsu.co.jp
+  * 	Nifty:	HBG02665
+  */
+ 
+ #ifdef JIV
+ 
+ #include <InterViews/font.h>
+ #include <IV-X11/Xlib.h>
+ #include <IV-X11/xfont.h>
+ #include <IV-X11/xjivfunc.h>
+ #include <stdio.h>
+ #include <stream.h>
+ 
+ extern short JIVGetLeftBearing(const char* s, int len, FontRep* f1,
+ 			       FontRep* f2)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     if ((const unsigned char)(*s) < 0x80) {
+ 	XTextExtents(f1->font_, s, len, &dir, &asc, &des, &c);
+     } else {
+ 	XTextExtents16(f2->font_, (XChar2b*)s, len / 2, &dir, &asc, &des, &c);
+     }
+     return c.lbearing;
+ }
+ 
+ 
+ extern short JIVGetRightBearing(const char* s, int len, FontRep* f1,
+ 				FontRep* f2)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)s;
+     int n;
+     short rb = 0;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[len + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+ 
+     for (n = 0; n < len; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    rb += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    rb += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    *ssp = *p;
+ 	    *(ssp + 1) = *(p + 1);
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 			   &dir, &asc, &des, &c);
+ 	    rb += c.rbearing;
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents(f1->font_, (const char*)ss, sl,
+ 			 &dir, &asc, &des, &c);
+ 	    rb += c.rbearing;
+ 	}
+     }
+     return rb;
+ }
+ 
+ extern short JIVGetWidth(const char* s, int len, FontRep* f1,
+ 			 FontRep* f2)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)s;
+     int n;
+     short w = 0;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[len + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+ 
+     for (n = 0; n < len; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    w += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    w += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    *ssp = *p;
+ 	    *(ssp + 1) = *(p + 1);
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 			   &dir, &asc, &des, &c);
+ 	    w += c.width;
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents(f1->font_, (const char*)ss, sl,
+ 			 &dir, &asc, &des, &c);
+ 	    w += c.width;
+ 	}
+     }
+     return w;
+ }
+ 
+ extern short JIVGetAscent(const char* s, int len, FontRep* f1,
+ 			  FontRep* f2)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)s;
+     int n;
+     short a = 0;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[len + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+ 
+     for (n = 0; n < len; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    if (c.ascent > a) {
+ 			a = c.ascent;
+ 		    }
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    if (c.ascent > a) {
+ 			a = c.ascent;
+ 		    }
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    *ssp = *p;
+ 	    *(ssp + 1) = *(p + 1);
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 			   &dir, &asc, &des, &c);
+ 	    if (c.ascent > a) {
+ 		a = c.ascent;
+ 	    }
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents(f1->font_, (const char*)ss, sl,
+ 			 &dir, &asc, &des, &c);
+ 	    if (c.ascent > a) {
+ 		a = c.ascent;
+ 	    }
+ 	}
+     }
+     return a;
+ }
+ 
+ extern short JIVGetDescent(const char* s, int len, FontRep* f1,
+ 			   FontRep* f2)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)s;
+     int n;
+     short d = 0;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[len + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+     
+     for (n = 0; n < len; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    if (c.ascent > d) {
+ 			d = c.descent;
+ 		    }
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    if (c.ascent > d) {
+ 			d = c.descent;
+ 		    }
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    *ssp = *p;
+ 	    *(ssp + 1) = *(p + 1);
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 			   &dir, &asc, &des, &c);
+ 	    if (c.ascent > d) {
+ 		d = c.descent;
+ 	    }
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XTextExtents(f1->font_, (const char*)ss, sl,
+ 			 &dir, &asc, &des, &c);
+ 	    if (c.ascent > d) {
+ 		d = c.descent;
+ 	    }
+ 	}
+     }
+     return d;
+ }
+ 
+ void JIVDrawString(XDisplay *dpy, XDrawable d, GC gc, const Font* f,
+ 		   int x, int y, unsigned char* text, int index,
+ 		   Display* ivd)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)text;
+     int n;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[index + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+     FontRep* f1 = f->rep(ivd);
+     FontRep* f2 = f->rep2byte(ivd);
+     boolean isEuc = ((f2->font_->min_byte1 > 128) ? true : false);
+     const CompositeFont* cmpf = f->getCompositeFont();
+ 
+     for (n = 0; n < index; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XSetFont(dpy, gc, f2->font_->fid);
+ 		    XDrawString16(dpy, d, gc, x, y, (XChar2b*)ss, sl / 2);
+ 		    if (cmpf->displayBold()) {
+ 			XDrawString16(dpy, d, gc, x, y - 1,
+ 				      (XChar2b*)ss, sl / 2);
+ 		    }
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    x += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XSetFont(dpy, gc, f1->font_->fid);
+ 		    XDrawString(dpy, d, gc, x, y, (const char*)ss, sl);
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    x += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    if (isEuc) {
+ 		*ssp = *p;
+ 		*(ssp + 1) = *(p + 1);
+ 	    } else {
+ 		*ssp = *p & 0x7f;
+ 		*(ssp + 1) = *(p + 1) & 0x7f;
+ 	    }
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XSetFont(dpy, gc, f2->font_->fid);
+ 	    XDrawString16(dpy, d, gc, x, y, (XChar2b*)ss, sl / 2);
+ 	    if (cmpf->displayBold()) {
+ 		XDrawString16(dpy, d, gc, x, y - 1, (XChar2b*)ss, sl / 2);
+ 	    }
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XSetFont(dpy, gc, f1->font_->fid);
+ 	    XDrawString(dpy, d, gc, x, y, (const char*)ss, sl);
+ 	}
+     }
+ }
+ 
+ void JIVDrawImageString(XDisplay *dpy, XDrawable d, GC gc, const Font* f,
+ 		   int x, int y, unsigned char* text, int index,
+ 		   Display* ivd)
+ {
+     XCharStruct c;
+     int dir, asc, des;
+     const unsigned char* p = (const unsigned char*)text;
+     int n;
+     boolean in2bytechar = false;
+     unsigned char* ss = new unsigned char[index + 1];
+     unsigned char* ssp = ss;
+     int sl = 0;
+     FontRep* f1 = f->rep(ivd);
+     FontRep* f2 = f->rep2byte(ivd);
+     boolean isEuc = ((f2->font_->min_byte1 > 128) ? true : false);
+     const CompositeFont* cmpf = f->getCompositeFont();
+ 
+     for (n = 0; n < index; n++) {
+ 	if (*p < 0x80) {
+ 	    /* in one-byte character */
+ 	    if (in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XSetFont(dpy, gc, f2->font_->fid);
+ 		    XDrawImageString16(dpy, d, gc, x, y, (XChar2b*)ss, sl / 2);
+ 		    if (cmpf->displayBold()) {
+ 			XDrawImageString16(dpy, d, gc, x, y - 1,
+ 					   (XChar2b*)ss, sl / 2);
+ 		    }
+ 		    XTextExtents16(f2->font_, (XChar2b*)ss, sl / 2,
+ 				   &dir, &asc, &des, &c);
+ 		    x += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = false;
+ 	    }
+ 	    *ssp = *p;
+ 	    ssp++, sl++, p++;
+ 	} else {
+ 	    /* in two-byte character */
+ 	    if (!in2bytechar) {
+ 		if (sl > 0) {
+ 		    *ssp = '\0';
+ 		    XSetFont(dpy, gc, f1->font_->fid);
+ 		    XDrawImageString(dpy, d, gc, x, y, (const char*)ss, sl);
+ 		    XTextExtents(f1->font_, (const char*)ss, sl,
+ 				 &dir, &asc, &des, &c);
+ 		    x += c.width;
+ 		    ssp = ss;
+ 		    sl = 0;
+ 		}
+ 		in2bytechar = true;
+ 	    }
+ 	    if (isEuc) {
+ 		*ssp = *p;
+ 		*(ssp + 1) = *(p + 1);
+ 	    } else {
+ 		*ssp = *p & 0x7f;
+ 		*(ssp + 1) = *(p + 1) & 0x7f;
+ 	    }
+ 	    ssp +=2, sl += 2, p += 2, n++;
+ 	}
+     }
+     if (in2bytechar) {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XSetFont(dpy, gc, f2->font_->fid);
+ 	    XDrawImageString16(dpy, d, gc, x, y, (XChar2b*)ss, sl / 2);
+ 	    if (cmpf->displayBold()) {
+ 		XDrawImageString16(dpy, d, gc, x, y - 1,
+ 				   (XChar2b*)ss, sl / 2);
+ 	    }
+ 	}
+     } else {
+ 	if (sl > 0) {
+ 	    *ssp = '\0';
+ 	    XSetFont(dpy, gc, f1->font_->fid);
+ 	    XDrawImageString(dpy, d, gc, x, y, (const char*)ss, sl);
+ 	}
+     }
+ }
+ 
+ #endif /* JIV */
diff -cNr ivtools-0.6.orig/src/IV-X11/xwindow.c ivtools-0.6/src/IV-X11/xwindow.c
*** ivtools-0.6.orig/src/IV-X11/xwindow.c	Wed Jan 21 09:28:04 1998
--- ivtools-0.6/src/IV-X11/xwindow.c	Wed Jan 28 20:32:13 1998
***************
*** 1805,1810 ****
--- 1805,1813 ----
      if (s->value_is_on("synchronous")) {
  	XSynchronize(d.display_, True);
      }
+ #ifdef JIV
+     s->initCompositeFont();
+ #endif /* JIV */
  }
      
  Style* Display::style() const { return rep()->style_; }
***************
*** 1950,1955 ****
--- 1953,1961 ----
  	return false;
      }
      XNextEvent(dpy, &xe);
+ #ifdef JIV			/* 12 Jan 1992 eto@ai.cs.fujitsu.co.jp */
+     event.eventType = NullEvent;
+ #endif /* JIV */
      e.clear();
      e.window_ = WindowRep::find(xe.xany.window, d->wtable_);
      if (e.window_ != nil) {
diff -cNr ivtools-0.6.orig/src/InterViews/clthandler.c ivtools-0.6/src/InterViews/clthandler.c
*** ivtools-0.6.orig/src/InterViews/clthandler.c	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/InterViews/clthandler.c	Wed Jan 28 20:32:13 1998
***************
*** 0 ****
--- 1,43 ----
+ /*
+  * Copyright (c) 1991, 1992 Fujitsu Oita Software Laboratory Limited
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose is hereby granted without fee, provided
+  * that the above copyright notice and this permission notice appear in
+  * all copies of the software and related documentation, and the name of
+  * Fujitsu Oita Software Laboratory may not be used in any advertising or
+  * publicity relating to the software without specific, prior written
+  * prior permission of Fujitsu Oita Software Laboratory. 
+  * 
+  * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+  * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+  * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+  *
+  * IN NO EVENT SHALL FUJITSU OITA SOFTWARE LABORATORY BE LIABLE FOR ANY
+  * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR
+  * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+  * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY
+  * OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+  * PERFORMANCE OF THIS SOFTWARE.
+  *
+  * Author:  Toshihisa Eto, Fujitsu Oita Software Laboratory Limited, Japan
+  * 	E-Mail: eto@ai.cs.fujitsu.co.jp
+  * 	Nifty:	HBG02665
+  */
+ 
+ /*
+  * ClientMessageHandler - event handler
+  */
+ 
+ #ifdef JIV
+ 
+ #include <InterViews/clthandler.h>
+ 
+ ClientMessageHandler::ClientMessageHandler() { }
+ ClientMessageHandler::~ClientMessageHandler() { }
+ 
+ boolean ClientMessageHandler::handle_p(const Event&) {
+     return false;
+ }
+ 
+ #endif	/* JIV */
diff -cNr ivtools-0.6.orig/src/InterViews/label.c ivtools-0.6/src/InterViews/label.c
*** ivtools-0.6.orig/src/InterViews/label.c	Fri Feb 28 08:41:31 1997
--- ivtools-0.6/src/InterViews/label.c	Wed Jan 28 20:32:13 1998
***************
*** 110,117 ****
--- 110,130 ----
      const char* q = &p[text_->length()];
      Coord* cw = &char_widths_[0];
      for (; p < q; p++, cw++) {
+ #ifdef JIV
+ 	    Coord width;
+ 	    if (*p & 0x80) {
+ 		long ch = ((*p << 8) & 0xff00) | (*(p+1) & 0x00ff);
+ 		width = f->width(ch);
+ 		c->character(f, ch, width, color, x, y);
+ 		p++;
+ 	    } else {
+ 		width = f->width(*p);
+ 		c->character(f, *p, width, color, x, y);
+ 	    }
+ #else	    
  	Coord width = *cw;
  	c->character(f, *p, width, color, x, y);
+ #endif /* JIV */	    
  	x += width;
      }
  }
